package com.eco.plugin.xx.jlyhsjtb.controller;

import com.eco.plugin.xx.jlyhsjtb.config.PluginSimpleConfig;
import com.eco.plugin.xx.jlyhsjtb.db.bean.OrgEntity;
import com.eco.plugin.xx.jlyhsjtb.db.bean.UserEntity;
import com.eco.plugin.xx.jlyhsjtb.db.controller.DBController;
import com.eco.plugin.xx.jlyhsjtb.utils.*;
import com.fr.decision.webservice.annotation.LoginStatusChecker;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.third.springframework.stereotype.Controller;
import com.fr.third.springframework.web.bind.annotation.PostMapping;
import com.fr.third.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;


@Controller
@LoginStatusChecker(required = false)
@FunctionRecorder
public class ControllerSelf {

    @PostMapping(value = "/sp/client/api/syncIAMUser")
    @ResponseBody
    public void syncIAMUser(HttpServletRequest request,HttpServletResponse response){
        JSONObject userJson = Utils.getRequestBody(request);
        FRUtils.FRLogInfo("userJson : "+userJson.toString());
        JSONObject body = userJson.getJSONObject("body");
        operateUser(body);

        ResponseUtils.successResponse(response,"SUCCESS");
    }

    public static void operateUser(JSONObject userJson){
        //增删改的标志
        UserEntity userEntity = PubUtils.jsonObjToUserEntity(userJson);
        String flag = userEntity.getType();

        List<UserEntity> userList = new ArrayList<UserEntity>();
        userList.add(userEntity);

        if("delete".equals(flag)){
            FRUtils.FRLogInfo("deleteUser:"+userEntity.getEmplyNo() + ";time:"+ DateUtilSelf.getNow());

            DBController.batchUser(null,userList);
            try {
//                FRUserUtils.deleteByUsername(userEntity.getEmplyNo());
            } catch (Exception e) {
                FRUtils.FRLogError("删除用户失败:"+userEntity.getUsrId()+e.getMessage());
            }

            return ;
        }

        try {
            PubUtils.addOrUpdateUser(userList,userEntity);
        } catch (Exception e) {
            FRUtils.FRLogError("新增删除用户失败:"+userEntity.getUsrId()+e.getMessage());
        }
    }

    @PostMapping(value = "/sp/client/api/syncIAMOrg")
    @ResponseBody
    public void syncIAMOrg(HttpServletRequest request,HttpServletResponse response){
        JSONObject userJson = Utils.getRequestBody(request);
        FRUtils.FRLogInfo("orgJson : "+userJson.toString());

        JSONObject body = userJson.getJSONObject("body");
        //增删改的标志

        OrgEntity orgEntity = PubUtils.jsonObjToOrgEntity(body);
        String flag = orgEntity.getType();
        List<OrgEntity> orgList = new ArrayList<OrgEntity>();
        orgList.add(orgEntity);

        if("delete".equals(flag)){
            FRUtils.FRLogInfo("deleteorg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
            DBController.batchOrg(null,orgList);
            ResponseUtils.successResponse(response,"SUCCESS");
        }

        FRUtils.FRLogInfo("addOrUpdateOrg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
        DBController.batchOrg(orgList,null);
        ResponseUtils.successResponse(response,"SUCCESS");
    }

    public static void operateOrg(JSONObject orgJson){
        //增删改的标志
        OrgEntity orgEntity = PubUtils.jsonObjToOrgEntity(orgJson);
        List<OrgEntity> orgList = new ArrayList<OrgEntity>();
        orgList.add(orgEntity);
        String flag = orgEntity.getType();

        if("delete".equals(flag)){
            FRUtils.FRLogInfo("deleteorg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
            DBController.batchOrg(null,orgList);
            return ;
        }

        FRUtils.FRLogInfo("addOrUpdateOrg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
        DBController.batchOrg(orgList,null);
    }


    @PostMapping(value = "/getUserListPage")
    @ResponseBody
    public void getUserListPage(HttpServletRequest request,HttpServletResponse response){
        JSONObject param = Utils.getRequestBody(request);

        String url = PluginSimpleConfig.getInstance().getUserurl();

        String result = HttpUtils.HttpPostJson(url,param.toString(),null);

        if(Utils.isNullStr(result)){
            FRUtils.FRLogError("获取用户补偿数据异常");
            return ;
        }
        JSONObject userJson = new JSONObject(result);
        JSONObject body = userJson.getJSONObject("body");
        JSONArray usrInfArray = body.getJSONArray("usrInfArray");

        for(int i =0;i<usrInfArray.length();i++){
            operateUser(usrInfArray.getJSONObject(i));
        }
    }

    @PostMapping(value = "/getOrgListPage")
    @ResponseBody
    public void getOrgListPage(HttpServletRequest request,HttpServletResponse response){
        JSONObject param = Utils.getRequestBody(request);

        String url = PluginSimpleConfig.getInstance().getOrgurl();

        String result = HttpUtils.HttpPostJson(url,param.toString(),null);

        if(Utils.isNullStr(result)){
            FRUtils.FRLogError("获取机构补偿数据异常");
            return ;
        }
        JSONObject orgJson = new JSONObject(result);
        JSONObject body = orgJson.getJSONObject("body");
        JSONArray orgInfArray = body.getJSONArray("usrInfArray");

        for(int i =0;i<orgInfArray.length();i++){
            operateOrg(orgInfArray.getJSONObject(i));
        }
    }
}
