package com.eco.plugin.xx.jlyhsjtb.openapi.caller;

import com.eco.plugin.xx.jlyhsjtb.config.PluginSimpleConfig;
import com.eco.plugin.xx.jlyhsjtb.db.bean.OrgEntity;
import com.eco.plugin.xx.jlyhsjtb.db.controller.DBController;
import com.eco.plugin.xx.jlyhsjtb.utils.*;
import com.fr.decision.authority.AuthorityContext;
import com.fr.decision.authority.controller.DefaultAuthorityController;
import com.fr.decision.webservice.Response;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.tptj.plugin.hg.client.open.exception.CodeException;
import com.tptj.plugin.hg.client.open.impl.AbstractAPICaller;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class GetOrgCaller extends AbstractAPICaller {
    public static final GetOrgCaller CALLER = new GetOrgCaller();

    private final DefaultAuthorityController authorityController = AuthorityContext.getInstance().getAuthorityController();

    @Override
    public Response call(HttpServletRequest request, Map<String, Object> map, Map<String, Object> map1) throws CodeException {
        JSONObject param = Utils.getRequestBody(request);

        String url = PluginSimpleConfig.getInstance().getOrgurl();

        String result = HttpUtils.HttpPostJson(url,param.toString(),null);

        if(Utils.isNullStr(result)){
            FRUtils.FRLogError("获取机构补偿数据异常");
            return Response.ok("SUCCESS");
        }
        JSONObject orgJson = new JSONObject(result);
        JSONObject body = orgJson.getJSONObject("body");
        JSONArray orgInfArray = body.getJSONArray("orgInfArray");

        for(int i =0;i<orgInfArray.length();i++){
            operateOrg(orgInfArray.getJSONObject(i));
        }

        return Response.ok("SUCCESS");
    }

    @Override
    public String Description() {
        return "组织补偿接口";
    }

    public static void operateOrg(JSONObject orgJson){
        //增删改的标志
        OrgEntity orgEntity = PubUtils.jsonObjToOrgEntity(orgJson);
        List<OrgEntity> orgList = new ArrayList<OrgEntity>();
        orgList.add(orgEntity);
        String flag = orgEntity.getType();

        if("delete".equals(flag)){
            FRUtils.FRLogInfo("deleteorg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
            DBController.batchOrg(null,orgList);
            return ;
        }

        FRUtils.FRLogInfo("addOrUpdateOrg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
        DBController.batchOrg(orgList,null);
    }

}
