package com.eco.plugin.xx.jlyhsjtb.openapi.caller;

import com.eco.plugin.xx.jlyhsjtb.db.bean.OrgEntity;
import com.eco.plugin.xx.jlyhsjtb.db.controller.DBController;
import com.eco.plugin.xx.jlyhsjtb.utils.DateUtilSelf;
import com.eco.plugin.xx.jlyhsjtb.utils.FRUtils;
import com.eco.plugin.xx.jlyhsjtb.utils.PubUtils;
import com.eco.plugin.xx.jlyhsjtb.utils.Utils;
import com.fr.decision.authority.AuthorityContext;
import com.fr.decision.authority.controller.DefaultAuthorityController;
import com.fr.decision.webservice.Response;
import com.fr.json.JSONObject;
import com.tptj.plugin.hg.client.open.exception.CodeException;
import com.tptj.plugin.hg.client.open.impl.AbstractAPICaller;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class SyncIAMOrgCaller extends AbstractAPICaller {
    public static final SyncIAMOrgCaller CALLER = new SyncIAMOrgCaller();

    private final DefaultAuthorityController authorityController = AuthorityContext.getInstance().getAuthorityController();

    @Override
    public Response call(HttpServletRequest request, Map<String, Object> map, Map<String, Object> map1) throws CodeException {
        JSONObject userJson = Utils.getRequestBody(request);
        JSONObject body = userJson.getJSONObject("sysHead");
        //增删改的标志

        OrgEntity orgEntity = PubUtils.jsonObjToOrgEntity(body);
        String flag = orgEntity.getType();
        List<OrgEntity> orgList = new ArrayList<OrgEntity>();
        orgList.add(orgEntity);

        if("delete".equals(flag)){
            FRUtils.FRLogInfo("deleteorg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
            DBController.batchOrg(null,orgList);
            return Response.ok("SUCCESS");
        }

        FRUtils.FRLogInfo("addOrUpdateOrg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
        DBController.batchOrg(orgList,null);

        return Response.ok("SUCCESS");
    }

    @Override
    public String Description() {
        return "组织增量接口";
    }

    public static void operateOrg(JSONObject orgJson){
        //增删改的标志
        OrgEntity orgEntity = PubUtils.jsonObjToOrgEntity(orgJson);
        List<OrgEntity> orgList = new ArrayList<OrgEntity>();
        orgList.add(orgEntity);
        String flag = orgEntity.getType();

        if("delete".equals(flag)){
            FRUtils.FRLogInfo("deleteorg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
            DBController.batchOrg(null,orgList);
            return ;
        }

        FRUtils.FRLogInfo("addOrUpdateOrg:"+orgEntity.getBrCd()+ ";time:"+ DateUtilSelf.getNow());
        DBController.batchOrg(orgList,null);
    }

}
